#ifndef SEMAPHORE_H
#define SEMAPHORE_H

#include "spinlock.h"
#include "proc.h"

#define NPROC 64 // 最大进程数，通常在其他地方定义，可以在需要时引用

// 信号量数据结构
struct semaphore
{
  int value;                 // 信号量计数值
  struct spinlock lock;      // 用于保护信号量的自旋锁
  struct proc *queue[NPROC]; // 等待的进程队列
  int qsize;                 // 等待队列中的进程数量
};

// 信号量操作函数声明
void sem_init(struct semaphore *sem, int initial_value); // 初始化信号量
void sem_wait(struct semaphore *sem);                    // 信号量的 wait 操作
void sem_signal(struct semaphore *sem);                  // 信号量的 signal 操作

#endif // SEMAPHORE_H