#include "kernel/types.h"
#include "user/user.h"

void head(int fd, int lines)
{
  char buf[512];
  int n, line_count = 0;

  while ((n = read(fd, buf, sizeof(buf))) > 0 && line_count < lines)
  {
    for (int i = 0; i < n; i++)
    {
      write(1, &buf[i], 1); // 输出字符
      if (buf[i] == '\n')
      {
        line_count++;
        if (line_count >= lines)
        {
          break;
        }
      }
    }
  }
}

int main(int argc, char *argv[])
{
  if (argc != 3)
  {
    printf("Usage: head <filename> <lines>\n");
    exit(1);
  }
  int lines = atoi(argv[2]);
  int fd = open(argv[1], 0);
  if (fd < 0)
  {
    printf("head: cannot open %s\n", argv[1]);
    exit(1);
  }
  head(fd, lines);
  close(fd);
  exit(0);
}