#include "kernel/types.h"
#include "kernel/stat.h"
#include "user/user.h"

#define MAX_ITEMS 10

int empty[2];
int full[2];
int mutex[2];
int data_pipe[2];

void sem_wait(int sem[])
{
  char temp;
  read(sem[0], &temp, 1);
}

void sem_signal(int sem[])
{
  char temp = 'x';
  write(sem[1], &temp, 1);
}

void producer()
{
  for (int i = 0; i < 20; i++)
  {
    sem_wait(empty);
    sem_wait(mutex);
    write(data_pipe[1], &i, sizeof(int));
    printf("Producer: produced item %d\n", i);
    sem_signal(mutex);
    sem_signal(full);
  }
  exit(0);
}

void consumer()
{
  for (int i = 0; i < 20; i++)
  {
    sem_wait(full);
    sem_wait(mutex);
    int item;
    read(data_pipe[0], &item, sizeof(int));
    printf("Consumer: consumed item %d\n", item);
    sem_signal(mutex);
    sem_signal(empty);
  }
  exit(0);
}

int main()
{
  pipe(empty);
  pipe(full);
  pipe(mutex);
  pipe(data_pipe);

  for (int i = 0; i < MAX_ITEMS; i++)
  {
    sem_signal(empty);
  }
  sem_signal(mutex);

  if (fork() == 0)
  {
    producer();
  }
  else
  {
    consumer();
  }

  wait(0);
  exit(0);
}